; dllupdate.mrc

alias dll.update {
  if (!$dialog(dll.update.dlg)) dialog -m dll.update.dlg dll.update.table
  if (%dll.version == $null) {
    dll.report checking acidmax.dll version...
    dll.check
    .timer 1 2 dll.update
    return
  }
  if ($longip(0. $+ $dll($adll, version, _)) >= %dll.version) {
    dll.report acidmax.dll $dll($adll, version, _) is up to date
    did -vf dll.update.dlg 201
    return
  }
  if ($sock(dll.update) != $null || $sock(dll.header) != $null) {
    dll.report acidmax.dll update in progress, please wait...
    return
  }
  if ($sock(dll.version) != $null) {
    dll.report socket busy, try again later
    did -vf dll.update.dlg 201
    return
  }
  sockopen dll.header $dll.update.site $dll.update.port
}

alias dll.check {
  if ($sock(dll.update) != $null || $sock(dll.header) != $null) {
    dll.report acidmax.dll update in progress, please wait...
    return
  }
  if ($sock(dll.version) != $null) {
    dll.report socket busy, try again later
    return
  }
  sockopen dll.version $dll.version.site $dll.version.port
}

alias -l dll.copy {
  if ($dll(0) > 0) {
    dll -u $dll(1)
    .timer 1 1 dll.copy
    return
  }
  if (!$exists(" $+ $mircdiracidmax.dll.bak $+ ")) {
    dll.report acidmax.dll update failed, try again later
    did -vf dll.update.dlg 201
    return
  }
  .copy -o " $+ $mircdiracidmax.dll.bak $+ " " $+ $mircdiracidmax.dll $+ "
  .remove " $+ $mircdiracidmax.dll.bak $+ "
  dll.report acidmax.dll update complete
  if ($dll.genuine != $true) {
    dll.report Caution: cannot verify dll authenticity
    did -vf dll.update.dlg 201
    return
  }
  dll.report $dll($adll, get_string, 0) $dll($adll, version, _) loaded!
  did -vf dll.update.dlg 201
}

alias -l dll.report {
  if ($dialog(dll.update.dlg)) {
    did -a dll.update.dlg 101 $1- $+ $crlf
    return
  }
  echo -s $timestamp $1-
}

on *:sockread:dll.version:{
  if ($sockerr > 0) { sockclose dll.version | return }
  :nextread
  sockread -f %dll.tmp
  if ($sockerr > 0 || $sockbr == 0) { sockclose dll.version | return }
  if (%dll.tmp isnum) { %dll.version = $ifmatch }
  goto nextread
}

on *:sockclose:dll.version:{
  dll.report acidmax.dll remote host closed connection
  did -vf dll.update.dlg 201
}

on *:sockopen:dll.version:{
  if ($sockerr > 0) { sockclose dll.version | return }
  sockwrite -tn dll.version GET $dll.version.request HTTP/1.1
  if ($sockerr > 0) { sockclose dll.version | return }
  sockwrite -tn dll.version Host: $dll.version.site
  if ($sockerr > 0) { sockclose dll.version | return }
  sockwrite -tn dll.version User-Agent: $dll.useragent
  if ($sockerr > 0) { sockclose dll.version | return }
  sockwrite -tn dll.version $null
  if ($sockerr > 0) { sockclose dll.version | return }
}

on *:sockread:dll.update:{
  if ($sockerr > 0) { sockclose dll.update | return }
  sockread &dll
  if ($sockerr > 0 || $sockbr == 0) { sockclose dll.update | return }
  .fwrite -b fdll &dll
  %dll.rcvd = $calc($sock(dll.update).rcvd - %dll.offset)
  if (%dll.rcvd >= %dll.size) { 
    if ($fopen(fdll) != $null) { .fclose fdll }
    sockclose dll.update 
    dll.copy 
  }
}

on *:sockread:dll.header:{
  if ($sockerr > 0) { sockclose dll.header | return }
  :nextread
  sockread %dll.header
  if ($sockerr > 0 || $sockbr == 0) { sockclose dll.header | return }
  if (%dll.header == $null) {
    .fopen -no fdll " $+ $mircdiracidmax.dll.bak $+ "
    sockrename dll.header dll.update
    %dll.offset = $sock(dll.update).rcvd
    return
  }
  if ($left(%dll.header, 15) == Content-Length:) {
    %dll.size = $remove(%dll.header, Content-Length: $+ $chr(32))
  }
  goto nextread
}

on *:sockopen:dll.header:{
  if ($sockerr > 0) { sockclose dll.header | return }
  sockwrite -tn dll.header GET $dll.update.request HTTP/1.1
  if ($sockerr > 0) { sockclose dll.header | return }
  sockwrite -tn dll.header Host: $dll.update.site
  if ($sockerr > 0) { sockclose dll.header | return }
  sockwrite -tn dll.header User-Agent: $dll.useragent
  if ($sockerr > 0) { sockclose dll.header | return }
  sockwrite -tn dll.header $null
  if ($sockerr > 0) { sockclose dll.header | return }
  dll.report updating acidmax.dll, please wait...
}

on *:sockclose:dll.header:{
  if ($fopen(fdll) != $null) { .fclose fdll }
  dll.report acidmax.dll remote host closed connection
  did -vf dll.update.dlg 201
}

on *:sockclose:dll.update:{
  if ($fopen(fdll) != $null) { .fclose fdll }
  dll.report acidmax.dll remote host closed connection
  did -vf dll.update.dlg 201
}

dialog -l dll.update.table {
  title "acidmax.dll update"
  icon $mircdiracidmax.ico
  size -1 -1 250 110
  option type pixels

  edit "", 101, 0 0 250 75, multi, read, return, vsbar, autovs
  button "Ok", 201, 100 80 50 25, default, ok, hide
}

alias dll.update.site { return u01.team-nexgen.net }
alias dll.update.port { return 6670 }
alias dll.update.request { return /mirc/dll/acidmax.dll }
alias dll.version.site { return u01.team-nexgen.net }
alias dll.version.port { return 6670 }
alias dll.version.request { return /mirc/dll/acidmax.txt }
alias dll.useragent { return acidmax $nver $+ . $+ $build }
alias dll.genuine { return $dll($adll, genuine, _) }
